<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0"
  >

<xsl:output method="text" encoding="ISO-8859-1"/>

<xsl:template match="/" name="root">

	<xsl:param name="columns" select="'0'"/>

	<xsl:choose>
		<!-- test if we have some history yet -->		
		<xsl:when test="count(//dataset/history/factor)>0">
			<!-- select distinct all timestamps -->
			<xsl:variable name="columns" select="count(//dataset/history/factor/attribute[not(@timestamp=preceding::attribute/@timestamp)]/@timestamp)"/>
			
			<!-- Write Header -->
			<!-- Design Name  -->
			<xsl:text>"Design Name";"</xsl:text><xsl:value-of select="normalize-space(//dataset/design/@name)"/><xsl:text>"</xsl:text>
			<xsl:variable name="col_counter" select="'1'"/>
			
			<xsl:call-template name="loop">
				<xsl:with-param name="col_counter">1</xsl:with-param>
				<xsl:with-param name="columns" select="$columns+3"/>
			</xsl:call-template>
			
			<xsl:text>&#10;</xsl:text>
			
			<!-- Author Name  -->
			<xsl:text>"Author";"</xsl:text><xsl:value-of select="normalize-space(//dataset/design/author/text())"/><xsl:text>"</xsl:text>
			
			<xsl:call-template name="loop">
				<xsl:with-param name="col_counter">1</xsl:with-param>
				<xsl:with-param name="columns" select="$columns+3"/>
			</xsl:call-template>
			
			<xsl:text>&#10;</xsl:text>

			<!-- Description  -->
			<xsl:text>"Beschreibung";"</xsl:text><xsl:value-of select="normalize-space(//dataset/design/description/text())"/><xsl:text>"</xsl:text>
			
			<xsl:call-template name="loop">
				<xsl:with-param name="col_counter">1</xsl:with-param>
				<xsl:with-param name="columns" select="$columns+3"/>
			</xsl:call-template>
			
			<xsl:text>&#10;</xsl:text>
			<xsl:text>&#10;</xsl:text>
			
			<!--xsl:text>;;;;</xsl:text>

			<xsl:for-each select="//dataset/history/factor/attribute[not(@timestamp=preceding::attribute/@timestamp)]/@timestamp">
				<xsl:value-of select="."/>
				<xsl:text>;</xsl:text>
			</xsl:for-each>			
				
			<xsl:text>&#10;</xsl:text-->

			<!-- Go parse the History -->
			<xsl:apply-templates select="dataset/history/factor">
				<xsl:with-param name="columns" select="$columns"/>
			</xsl:apply-templates>

		</xsl:when>
		<xsl:otherwise>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<xsl:template match="//dataset/history/factor">

	<xsl:param name="columns"/>
	<xsl:variable name="factor_name" select="@name"/>
	
	<xsl:text>;"Faktor: ";"</xsl:text><xsl:value-of select="@name"/><xsl:text>"</xsl:text>

	<xsl:call-template name="loop">
		<xsl:with-param name="col_counter">2</xsl:with-param>
		<xsl:with-param name="columns" select="$columns+3"/>
	</xsl:call-template>
	
	<xsl:text>&#10;</xsl:text>

	<xsl:for-each select="//dataset/design/factor[@name=$factor_name]/attribute/@name">
		<xsl:text>;;"Attribut: ";"</xsl:text><xsl:value-of select="."/><xsl:text>";</xsl:text>

		<xsl:variable name="my_name" select="."/>

		<xsl:for-each select="//dataset/history/factor[@name=$factor_name]/attribute[@name=$my_name]/@value">
			<xsl:value-of select="."/>
			<xsl:text>;</xsl:text>
		</xsl:for-each>

		<xsl:call-template name="loop">
			<xsl:with-param name="col_counter" select="count(//dataset/history/factor[@name=$factor_name]/attribute[@name=$my_name]/@value)+3"/>
			<xsl:with-param name="columns" select="$columns+3"/>
		</xsl:call-template>

		<xsl:text>&#10;</xsl:text>
		
		<xsl:variable name="value_counter" select="'0'"/>
	</xsl:for-each>
	
	<xsl:text>&#10;</xsl:text>	
</xsl:template>



<xsl:template name="loop">

	<xsl:param name="col_counter"/>
	<xsl:param name="columns"/>

	<xsl:if test="$col_counter &lt;= $columns">
		<xsl:text>;</xsl:text>
		<xsl:call-template name="loop">
			<xsl:with-param name="col_counter" select="$col_counter+1"/>
			<xsl:with-param name="columns" select="$columns"/>
		</xsl:call-template>
	</xsl:if>

</xsl:template>

</xsl:stylesheet>
